package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.visit.*;
import polyglot.types.*;
import polyglot.util.*;

// binary expressions appearing in predicates
public class PredJBinary_c extends Binary_c implements PredJBinary {

    public PredJBinary_c(Position pos, Expr left, Binary.Operator op,
			 Expr right) {
	super(pos, left, op, right);
    }


	// this method (and therefore this class!) turns out not to be
	// necessary.  in particular, it's perfectly ok to use
	// variables of type long, short, etc. in arithmetic
	// comparisons inside a predicate. the thing we can't support
	// (for now) is literals of these types (because they have
	// things like L on them, and they just may be too large), but
	// that's handled by restrictions in the parser and by the
	// canonicalizer visitor, which only computes constant values for
	// numeric constants of type int.

//      public Node typeCheck(TypeChecker tc) throws SemanticException {
//  	    // we impose some stronger restrictions than Java in predicates,
//  	    // because of limitations in the theorem prover.
//          Type l = left.type();
//  	Type r = right.type();

//  	if (op == GT || op == LT || op == GE || op == LE || op == ADD
//  	    || op == SUB || op == MUL) {
//  	    if (! (l.isInt() && r.isInt())) {
//  		throw new SemanticException("The " + op +
//  					    " operator must have integer "
//  					    + "operands.", position());
//  	    }
//  	}

//  	if (op == EQ || op == NE) {
//  	    if (l.isNumeric() && r.isNumeric()) {
//  		if (! (l.isInt() && r.isInt())) {
//  		    throw new SemanticException("Numeric operands to " + op
//  						+ " must be integers.",
//  						position());
//  		}
//  	    }
//  	}

//  	return super.typeCheck(tc);
//      }
}
