
package polyglot.ext.predj.ast;

import java.util.*;

import polyglot.ext.predj.types.*;

import polyglot.ext.jl5.ast.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.util.Position;

public class PredJClassBody_c extends JL5ClassBody_c {

    public PredJClassBody_c(Position pos, List members) {
        super(pos, members);
    }

	// we don't need this check any more (and the inherited implementation
	// doesn't work properly anyway); ITC will take care of checking for
	// duplicates, along with other ambiguities
    protected void duplicateMethodCheck(TypeChecker tc)
	throws SemanticException {}

    protected void duplicateErasureMethodCheck(TypeChecker tc)
	throws SemanticException{
        PredJTypeSystem ts = (PredJTypeSystem) tc.typeSystem();
        ArrayList l = new ArrayList(tc.context().currentClass().methods());
        for (int i = 0; i < l.size(); i++){
            PredJMethodInstance mi = (PredJMethodInstance)l.get(i);
            MethodInstance emi = erasureMethod(ts, mi);
            for (int j = i+1; j < l.size(); j++){
                PredJMethodInstance mj = (PredJMethodInstance)l.get(j);
		if (mi.hasDispatcherMate(mj)) {
			// these methods are part of the same method family
		    break;
		}
                MethodInstance emj = erasureMethod(ts, mj);
                if (isSameMethod(tc.typeSystem(), emi, emj)){
                    throw new SemanticException("Method "+mi+" and "+mj+" have the same erasure.", mj.position());
                }
            }
        }
    }
}
