
package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.util.*;
import polyglot.types.*;
import polyglot.visit.*;
import polyglot.ext.predj.types.*;

import polyglot.ext.jl5.ast.*;
import polyglot.ext.jl5.types.FlagAnnotations;

public class PredJFormal_c extends JL5Formal_c implements PredJFormal {
    protected int paramPos = -1;
    
    public PredJFormal_c(Position pos, FlagAnnotations flags, TypeNode type,
			 String name) {
	super(pos, flags, type, name);
    }

    public PredJFormal_c(Position pos, FlagAnnotations flags, TypeNode type,
			 String name, boolean variable) {
	super(pos, flags, type, name, variable);
    }
    
	// record which number formal this is in the associated method
    public void setParamPosition(int paramPos) {
	this.paramPos = paramPos;
    }

    public int paramPosition() {
	return paramPos;
    }

        /** Build type objects for the formal. */
    public Node buildTypes(TypeBuilder tb) throws SemanticException {
        PredJFormal_c n = (PredJFormal_c) super.buildTypes(tb);

        PredJTypeSystem ts = (PredJTypeSystem) tb.typeSystem();

        LocalInstance li = ts.formalInstance(position(), Flags.NONE,
					     ts.unknownType(position()),
					     name(), paramPosition());

        return n.localInstance(li);
    }

    public Node disambiguate(AmbiguityRemover ar) throws SemanticException {
        if (declType().isCanonical() &&
	    ! localInstance().type().isCanonical()) {
            PredJTypeSystem ts = (PredJTypeSystem) ar.typeSystem();
            LocalInstance li = ts.formalInstance(position(), flags(),
						 declType(), name(),
						 paramPosition());
            return localInstance(li);
        }

        return this;
    }

}

    
