package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.types.*;
import polyglot.ext.predj.types.*;
import polyglot.util.*;
import java.util.*;
import polyglot.ext.jl5.ast.*;
import polyglot.ext.jl5.types.FlagAnnotations;

/**
 * NodeFactory for predj extension.
 */
public interface PredJNodeFactory extends JL5NodeFactory {

   PredJPredMethodDecl PredJPredMethodDecl(
	Position pos, FlagAnnotations flags, TypeNode returnType,
	String name, List argTypes, List throwConstraints,
	Block body, List typeParams, PredicateNode predicate);
    
    PredJBinary PredJBinary(Position pos, Expr left,
				    Binary.Operator op, Expr right);

    PredicateNode PredicateNode(Position pos, Expr predicateExpr);

    PredJDispatcher PredJDispatcher(List dispatcherMates,
				    PredJTypeSystem ts);

    SpecializerNode SpecializerNode(
	Position pos, Expr target, TypeNode specializer);
    
    BindingSpecializerNode BindingSpecializerNode(
	Position pos, Expr target, TypeNode specializer,
	PredicateVarBinding localBinding);

    BindingNode BindingNode(
	Position pos, Expr target,
	PredicateVarBinding localBinding);

    PredicateVarBinding PredicateVarBinding(Position pos, Flags flags,
					    TypeNode type, String name,
					    Expr init);

}
