package polyglot.ext.predj.ast;

import polyglot.ast.*;
import polyglot.types.Context;
import polyglot.ext.predj.types.PredJTypeSystem;

import java.util.*;

/** Adds a predicate to method declarations. **/
public interface PredJPredMethodDecl extends PredJMethodDecl {

    PredicateNode predNode();

	// keeps track of the specialized types of formal parameters in
	// a predicate; a set of SpecializerNodes
    public Set formalBindings();

    	// keeps track of the new variable bindings in 
	// a predicate; a list of BindingSpecializerNodes;
	// it's a list to keep the order of binding, since later ones
	// may refer to earlier ones.
    public List localBindings();


    public PredJPredMethodDecl bindings(Set formalBindings,
					List localBindings);

    public Node createPredicate(Context c, PredJTypeSystem ts);

}
