package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

import polyglot.ext.jl5.types.*;

/* The interface for a PredJ method instance. */

public interface PredJMethodInstance extends JL5MethodInstance {

	// This signature is inherited from MethodInstance.
	// In the context of JPred, it returns true if the two methods
	// are in the same method family (i.e., have the same name and
	// formal argument types).
    boolean isSameMethod(MethodInstance m);

	// In the context of JPred, this method returns true if the two
	// methods are the same textual method.
    boolean equals(Object o);
    
	// does this method have a predicate?
    public boolean hasPredicate();
    
    public boolean throwsSameSet(PredJMethodInstance mi);

    	// a dispatcher mate is a method with the same name, formal argument
	// types, and receiver.
    public boolean hasDispatcherMate(PredJMethodInstance mj);

}
