package polyglot.ext.predj.types;

import java.util.*;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.frontend.Source;

import polyglot.ext.jl5.types.*;

public class PredJParsedClassType_c extends JL5ParsedClassType_c
    implements PredJParsedClassType {

    protected List dispatchers;

//     protected PredJParsedClassType_c() {
// 	super();
//     }

    public PredJParsedClassType_c(TypeSystem ts, LazyClassInitializer init, 
				  Source fromSource) {
	super(ts, init, fromSource);
    }

    public List dispatchers() {
	    // we build dispatchers from the set of methods.
	if (dispatchers == null) {
	    List methods = methods();
	    buildDispatchers(methods);
	}
	return dispatchers;
    }

	// partition a list of methods (MethodInstance) into dispatchers.
	// this code is regrettably similar to that in DispatcherBuilder,
	// but this one works on MethodInstances while that one works on
	// MethodDecls.  I don't see an easy way to unify them.
    protected void buildDispatchers(List methods) {
	dispatchers = new LinkedList();
	ArrayList l = new ArrayList(methods);
	while (! l.isEmpty()) {
	    PredJMethodInstance mi = (PredJMethodInstance) l.get(0);
	    List dispatcherMates = dispatcherMates(mi, l);
	    l.removeAll(dispatcherMates);
		// if there is only one mate for this gf and the
		// method does not have a predicate, then there
		// is no need to create a dispatcher method
	    if (dispatcherMates.size() > 1 || mi.hasPredicate()) {
		    // remove any abstract methods and set the flag
		    // appropriately if there are any.
		boolean hasAbstractMethod = false;
		Iterator i = dispatcherMates.iterator();
		while (i.hasNext()) {
		    PredJMethodInstance pmi = (PredJMethodInstance) i.next();
		    if (pmi.flags().isAbstract()) {
			hasAbstractMethod = true;
			i.remove();
		    }
		}
		dispatchers.add(((PredJTypeSystem) typeSystem())
				.dispatcherInstance(dispatcherMates,
						    hasAbstractMethod));
	    }
	}
    }

	// return all dispatcher mates of mi in methods
    protected List dispatcherMates(PredJMethodInstance mi, List methods) {
	List l = new ArrayList();
	Iterator i = methods.iterator();
	while(i.hasNext()) {
	    PredJMethodInstance mi2 = (PredJMethodInstance) i.next();
	    if (mi.hasDispatcherMate(mi2)) {
		l.add(mi2);
	    }
	}
	return l;
    }

}
