package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ext.jl.types.*;
import polyglot.util.*;
import java.util.*;

/* The type information for a PredJ method that has a predicate. */

public class PredJPredMethodInstance_c extends PredJAbstractMethodInstance_c
    implements PredJPredMethodInstance
{
    protected Predicate predicate;

    public PredJPredMethodInstance_c(TypeSystem ts, Position pos,
				     ReferenceType container,
				     Flags flags, Type returnType, String name,
				     List formalTypes, List excTypes,
				     Predicate predicate) {
        super(ts, pos, container, flags, returnType, name,
	      formalTypes, excTypes);
	this.predicate = predicate;
    }

    public Predicate predicate() {
	return predicate;
    }

    public PredJPredMethodInstance predicate(Predicate pred) {
        PredJPredMethodInstance_c n = (PredJPredMethodInstance_c) copy();
	n.predicate = pred;
	return n;
    }
    
	// does this method have a predicate?
    public boolean hasPredicate() {
	return true;
    }
    
    public String signature() {
	String s = super.signature();
	return s + " when " + predicate().toString();
    }

        
//     /** Returns true iff <this> is the same method as <m> */
//     public boolean isSameMethodImpl(MethodInstance m) {
// 	    // ambiguity checking will determine if two methods are duplicates
// 	    // semantically.  this method just uses pointer equality
// 	return m == this;
//     }
    
}
