package polyglot.ext.predj.types;

import polyglot.types.*;

import java.io.Serializable;
import java.util.*;

public interface Predicate extends Serializable {

    public Type type();
    
	// produce a set of the specializer types (Types) mentioned in
	// the predicate
    public Set specializers();

	// Produce a set of targets (a target can be a PredicateTarget or
	// a PredicateArrayAccess) mentioned in the predicate.  These targets
	// include anything that would be produced from calling names() unioned
	// with all PredicateArrayAccesses that occur in the predicate.
    public Set targets();
    
	// Produce a set of names (may ONLY be of PredicateTarget type) mentioned in the
	// predicate.  This is a set of all variables referred to in a predicate with the
	// exception of any array accesses.  The PredicateArrayAccess types (along with
	// PredicateTarget types) can be retreived using targets().
    public Set names();
}
