package polyglot.ext.predj.types;

import polyglot.types.*;
import polyglot.ast.ArrayAccess;

import java.util.*;

// the type information for an array access expression
// appearing in a predicate
public class PredicateArrayAccess_c extends Predicate_c
    implements PredicateArrayAccess {

    protected Predicate array;    
    protected Predicate index;	

    public PredicateArrayAccess_c(Predicate array, Predicate index, Type type) {
	super(type);
	this.array = array;	
	this.index = index;
    }

	//private String makeName(Predicate array, Predicate index)
	//{}
/*
    public String name() {
	return name;
    }

	// May not be needed
	public String baseName() {
	return name.substring(0, name.indexOf('['));
    }
	
	// May not be needed
    protected int dimsHelper(String base) {
	int dims = 0;
	int idx = base.lastIndexOf(']');
	
	if (idx == -1)
	    return dims;

	   // else	
	return dims + 1 + dimsHelper(base.substring(0, base.lastIndexOf('[')));
    }	

	// May not be needed
    public int dims() {
	return dimsHelper(name());
    }
*/	
       
    public Predicate array() {
	return array;
    }

    public Predicate index() {
	return index;
    }

    private String GetArrayName() {
	if (array instanceof PredicateArrayAccess)
	    return ((PredicateArrayAccess) array).ArrayAccess();
	else
	    return array.toString();
    }

    private String GetIndexName() {
      if (index instanceof PredicateArrayAccess)
	  return ((PredicateArrayAccess) index).ArrayAccess();
      else
	  return index.toString();
    }
    
    public String ArrayAccess()	{
	return GetArrayName() + "[" + GetIndexName() + "]";
    }

    public Set specializers() {
	Set s = array().specializers();       
	s.addAll(index().specializers());
	return s;
    }

    public Set names() {
	Set s = array().names();
	s.addAll(index().names());	
	return s;
    }

    public Set targets() {	
	Set s = array().targets();
	s.addAll(index().targets());
	// Finally add the PredicateArrayAccess itself to the list of targets.
	s.add(this); 	
	return s;
    }
}
