package polyglot.ext.predj.types;

import polyglot.types.*;

import java.util.*;

// the type information for a call appearing in a predicate
public class PredicateCall_c extends PredicateTarget_c implements PredicateCall {

    protected List arguments, argumentTypes;
    
    public PredicateCall_c(String name, List arguments,
                           Type returnType, List argumentTypes) {
	super(name, returnType);
        this.arguments = arguments;
        this.argumentTypes = argumentTypes;
    }

    public boolean equals(Object o) {
	if (!(o instanceof PredicateCall))
	    return super.equals(o);

	PredicateCall c = (PredicateCall) o;
	if (!name.equals(c.name()))
            return false;
        if (!type.equals(c.type()))
            return false;
        if (argumentTypes.size() != c.argumentTypes().size())
            return false;
        Iterator at = argumentTypes.iterator(), a = arguments.iterator(),
                 cat = c.argumentTypes().iterator(), ca = c.arguments().iterator();
        while (at.hasNext())
            if ((!at.next().equals(cat.next())) ||
                (!a.next().equals(ca.next())))
                return false;
        return true;
    }

    public String name() {
        return name;
    }

    public List arguments() {
        return arguments;
    }

    public List argumentTypes() {
        return argumentTypes;
    }

    public Set specializers() {
        Set r = super.specializers();
        Iterator a = arguments.iterator();
        while (a.hasNext())
            r.addAll(((Predicate)a.next()).specializers());
        return r;
    }

    public Set targets() {
        Set r = super.targets();
        Iterator a = arguments.iterator();
        while (a.hasNext())
            r.addAll(((Predicate)a.next()).targets());
        return r;
    }

    public Set names() {
        Set r = super.names();
        Iterator a = arguments.iterator();
        while (a.hasNext())
            r.addAll(((Predicate)a.next()).names());
        return r;
    }
}

