package polyglot.ext.predj.types;

import java.util.*;

/* Represents the unknown type information of a predicate before it
   has been computed in the typechecking pass. */

public class UnknownPredicate_c extends Predicate_c
    implements UnknownPredicate {

    public UnknownPredicate_c() {
	super(null);
    }

    public String toString() {
	return "<unknown>";
    }

    public Set specializers() {
	throw new RuntimeException("specializers() should never be called " +
				   "on an UnknownPredicate_c");
    }

    public Set targets() {
	throw new RuntimeException("targets() should never be called " +
				   "on an UnknownPredicate_c");
    }
}
