package polyglot.ext.predj.util;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.ext.predj.ast.*;

import polyglot.types.*;

// given a canonical expr (see canonicalize.java), create a string
// representation of it

public class canonicalTargetName {

	// This may be deprecated by generating a field function for CVCL.
	// In any event, the below will not be used.
/*
    public static String mangleArrayAccess(String s) {
	System.out.println("ArrayAccess pre-mangling for field access: " + s);
	String mangledName = "";
	int i = 0;
	    
	while (i <= s.length() - 1) {
	    mangledName += s.substring(i, s.indexOf("[", i)) + "$Array";
		// Let's mangle it uniquely based on the index
	    if (s.indexOf("[", i) + 1 <= s.indexOf("]", i) - 1) {
		mangledName += s.substring(s.indexOf("[", i) + 1, s.indexOf("]", i) - 1);
		System.out.println("Here is the index: " + s.substring(s.indexOf("[", i) + 1, s.indexOf("]", i) - 1));
	    }
	    i = s.indexOf("]", i) + 1;
	}
	    
	mangledName = s.replace("[","$Array").replace("]", "");
	System.out.println("from canonicalTargetName_c.pj, mangledName = " + mangledName);
	return mangledName;
    }
*/
	    

    public static String canonicalTargetName(Receiver r) {
	if (r instanceof Local) {
	    return r.toString();
	} else if (r instanceof Field) {
	    Field f = (Field) r;
	    Receiver target = f.target();
	    String prefix = canonicalTargetName(target) + ".";
	    String name = f.name();
		// qualify the field name with its container's name, so we
		// don't confuse two fields where one hides the other
	    name = name + "$" + f.fieldInstance().container().toString();
	    return prefix + name;
	} else if (r instanceof Call) {
	    Call c = (Call) r;
	    Receiver target = c.target();
	    String prefix = canonicalTargetName(target) + ".";
	    String name = c.name();
	    name = name + "$" + c.methodInstance().container().toString();
	    return prefix + name;
	} else if (r instanceof Special) {
	    return r.toString();
	} else if (r instanceof Cast) {
	    Cast cast = (Cast) r;
	    // don't include the cast-to type in the name
	    return canonicalTargetName(cast.expr());
	} else if (r instanceof Lit) {
	    return r.toString();
	} else if (r instanceof TypeNode) {
	    return r.toString();
	} else if  (r instanceof ArrayAccess) {
	    ArrayAccess arr = (ArrayAccess) r;
	    return canonicalTargetName(arr.array()) + "[" +
		canonicalTargetName(arr.index()) + "]";
	} else {
	    throw new RuntimeException(
		"canonicalTargetName called on an unexpected expression "
		+ r);
	}
    }
}
