package polyglot.ext.predj.visit;

import polyglot.visit.*;
import polyglot.ast.*;
import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.predj.ast.*;

import polyglot.frontend.Job;

import java.util.*;

/** Visitor that performs implementation-side typechecking (i.e.,
    completeness and ambiguity checking) on each group of dispatcher mates.
**/
public class ImplementationSideTypeChecker extends ContextVisitor {
    
    public ImplementationSideTypeChecker(Job job, TypeSystem ts,
					 NodeFactory nf) {
	super(job, ts, nf);
    }

	// check completeness and ambiguity of a set of dispatcher mates
    protected Node leaveCall(Node n) throws SemanticException {
	if (n instanceof PredJDispatcher) 
	    return ((PredJDispatcher)n).implementationSideTypeCheck(this);

	else if (n instanceof PredJClassDecl) {
		// check concrete classes for completeness w.r.t. inherited gfs
		// that they don't override.  handles the case when an abstract
		// superclass only partially implements a gf (which we allow as
		// long as the subclass finishes the implementation).
	    return ((PredJClassDecl)n).implementationSideTypeCheck(this);
	} else
	    return super.leaveCall(n);
    }
}
