package polyglot.ext.predj.visit;

import polyglot.ast.*;
import polyglot.ext.jl.ast.*;
import polyglot.ext.predj.ast.*;
import polyglot.types.*;
import polyglot.ext.predj.types.*;
import polyglot.ext.predj.util.canonicalize;
import polyglot.visit.*;

import polyglot.frontend.Job;

// create the type information for a predicate expression

public class PredicateTypeCreator extends ContextVisitor {

    public PredicateTypeCreator(Job job, TypeSystem ts, NodeFactory nf) {
	super(job, ts, nf);
    }

    protected Node leaveCall(Node n) throws SemanticException {
	if (n instanceof PredJPredMethodDecl) {
	    PredJPredMethodDecl md = (PredJPredMethodDecl) n;
	    return md.createPredicate(context(),
				      (PredJTypeSystem) typeSystem());
	}
	return super.leaveCall(n);
    }
}    
